<!DOCTYPE html>

<!-----------------------------------------
  Mathématiques Spécifiques II (Algo. Num.)
  Projet - Automate cellulaire paramétrable
  09.06.2022

  Equipe 03 :	M. Allemann Jonas
			    M. Chappuis Sebastien
                Mme. Michel Jeanne
				M. Stouder Xavier
------------------------------------------>

<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>AN22_Projet_Eq03 - Doc - Cellular automation</title>
</head>
<body>
    <header>
        <h1>Projet - Automates Cellulaires</h1>
        <summary>
            <b>Cours :</b> Mathématiques Spécifiques II (Algo. Num.)<br>
            <b>Groupe 3 :</b> Jeanne Michel, Jonas Allemann, Sébastien Chappuis, Xavier Stouder.<br>
            <b>Présenté à :</b> Stephane Gobron<br>
            <b>Date :</b> 09.06.2022
        </summary>
    </header>

    <hr>
    <div>
        <a href="AN22_Projet_Eq03.html">Click here to return to the automaton</a>
    </div>

    <section id="doc">
    <h2>Contexte</h2>
    <p>
        Dans le cadre du projet de mathématiques spécifiques, nous avons choisi de développer un automate cellulaire.
        Un automate cellulaire est un objet qui évolue selon des règles simples et qui imite, d'une certaine manière, les capacités autoreproductrices des êtres vivants.
        Chaque cellule possèdera un état binaire, vivant ou mort, qui dépendra directement de ces voisins. Les règles de l'état d'une cellule peuvent être définies sous la forme d'une table de vérité.
    </p>

    <p>
        Le but de l'application est d'afficher un automate cellulaire dont les règles peuvent être définies par l'utilisateur en modifiant la table de vérité.</div>
        Cette table a été simplifiée pour présenter toutes les règles possibles. L'utilisateur peut activer les règles qu'il souhaite en cliquant simplement sur ces dernières.
        L'automate va évoluer en temps réel selon les règles définies. Il est possible d'activer un mode pour modifier automatiquement les règles afin que l'automate soit stable, c'est-à-dire que l'état des cellules change le moins possible.
    </p>

    <h2>Choix de développement</h2>
    <h3>Lien avec le cours</h3>
    <p>
        <!-- Modèle d'algo. num. -->
        En soi, le développement de l'automate cellulaire n'a pas de lien direct avec l'algorithmie numérique.
        Pour faire un lien avec le cours, nous analysons les différentes cellules. Cela comprend le nombre de cellules vivantes ainsi que la stabilité de l'automate.
        Durant le cours, nous avons cherché à passer de données continues à des données discrètes. Cependant, un automate cellulaire est par définition déjà discret.
        De ce fait, le but du projet est l'inverse : à partir de données discrètes, nous recherchons à obtenir des données continues pour stabiliser l'automate.
    </p>

    <h3>Mise en pratique</h3>
    <p>
        <!-- comment le modèle lié à l'algo. num. a été déployé-->
        L'analyse de la stabilité permet de faire évoluer les règles de manière automatique afin de créer un automate stable.
        Pour déterminer les règles à modifier, l'application va comparer la stabilité de l'automate sur les 100 dernières générations.
        Ensuite, nous prenons un échantillon des cellules de l'automate qui sera comparé à la génération précédente, ce qui permet de déterminer quelles sont les règles qui produisent de l'instabilité.
        A partir des statistiques obtenues sur cet échantillon, l'application va activer ou désactiver zéro ou plusieurs règles dans le but de trouver un ensemble de règles afin d'avoir une stabilité maximale.
        
    </p>

    <h2>Résultats</h2>
    <ul>
        <li>L'automate fonctionne en temps réel, chaque cellule va évoluer selon les règles définies ;</li>
        <li>
            L'utilisateur peut activer les règles avec le clic gauche de la souris et désactiver les règles avec le clic droit. Ces contrôles sont les mêmes sur la grille de l'automate, pour l'état des cellules ;
            <figure>
                <img src="Automate+Regles.PNG" alt="cellules et règles" />
                <figcaption>A gauche, la grille de l'automate avec les cellules vivantes en blanc. A droite, la table de vérité de l'automate, avec les règles effectives en bleu.</figcaption>
            </figure>
        </li>
        <li>
            Un graphe permet de visualiser l'état de l'automate sur plusieurs générations. Ce graphe contient les données analysées (à savoir le nombre de cellules vivantes et la stabilité) en pourcentage basé sur le nombre de cellules de l'automates ;<br>
            <figure>
                <img src="Graphe+stabilisation.PNG" alt="graphe et stabilisation"/>
                <figcaption>Le graphe se stabilise au fur à mesure des générations.</figcaption>
            </figure>
        </li>
        <li>L'application est en mesure de modifier activement les règles de vie pour les cellules afin d'arriver à un automate stable proche du 100%. C'est-à-dire que toutes cellules conservent leur état précédent ;</li>
        <li>
            Il est possible d'activer et paramétrer la fréquence pour la recherche de stabilité de l'automate. Un automate stable signifie que les cellules conservent leur état précédent ;<br>
            <figure>
                <img src="ReglesAuto+frequence.PNG" alt="règles et fréquence"/>
                <figcaption>La position du curseur détermine la fréquence d'adaptation. Tout à gauche pour adapter toutes les 100 générations, tout à droite pour adapter à chaque génération.</figcaption>
            </figure>
        </li>
    </ul>

    <h2>Discussion</h2>
    <h3>Conclusion</h3>
    <ul>
        <!-- Conclusion -->
        <li>Les règles qui s'appliquent aux cellules se présentent sous la forme d'une grille. Chaque case de cette grille correspond à une entrée de la table de vérité, mais représentée de manière visuelle;</li>
        <li>L'état de l'automate peut être visualisé en temps réel;</li>
        <li>L'interface utilisateur est relativement simple et permet à l'utilisateur d'interagir avec l'automate. Il a la possibilité de changer les règles et l'état d'une cellule.</li>
    </ul>
    <!-- Perspectives / améliorations -->
    <h3>Perspectives et améliorations</h3>
    <p>
        Parmi les améliorations envisageables, il y a la taille de l'automate. Actuellement, il s'adapte en fonction de l'espace disponible. Une option pour choisir le nombre de lignes et colonnes pourrait être intéressante.
        De plus, si la taille vient à changer, la totalité de l'automate est réinitialisée, ce qui peut être frustrant pour l'utilisateur.

        La possibilité de paramétrer le niveau de stabilité pourrait également être envisagée, afin de trouver des règles permettant à l'automate d'avoir un nombre de cellules actives avec plus ou moins de bruit.

        Enfin, une option d'exportation de la règle serait une bonne idée. Cela permettrait de les sauvegarder et de les réutiliser plus tard, voir même les partager pour d'autres automates.
    </p>

    <h2>Références</h2>
    <ol>
        <li>BACQUEY Nicolas. Automates Cellulaires : Aspects algorithmiques des configurations périodiques en toute dimension. Informatique [cs]. Université de Caen Normandie, 2015. Français. fftel-01261424f. <a href="https://tel.archives-ouvertes.fr/tel-01261424/document" target="_blank">Lien vers le document</a></li>
        <li>Tables of Cellular Automaton Properties. Originally published in Theory and Applications of Cellular Automata. World Scientific Publishing Co. Ltd ., pages 485-557 (1986). <a href="https://content.wolfram.com/uploads/sites/34/2020/07/cellular-automaton-properties.pdf" target="_blank">Lien vers le PDF</a></li>
        <li>Automate cellulaire. Page Wikipédia. <a href="https://fr.wikipedia.org/wiki/Automate_cellulaire" target="_blank">Lien Wikipédia</a></li>
        <li>Le jeu de la vie. 8 décembre 2017. Vidéo Youtube de ScienceEtonnante. <a href="https://www.youtube.com/watch?v=S-W0NX97DB0" target="_blank">Lien Youtube</a></li>
        <li>Jeu de la vie (interactif). 2022. DCODE. <a href="https://www.dcode.fr/jeu-de-la-vie" target="_blank">Lien vers la page interactive</a></li>
        <li>BREDÈCHE Nicolas. Automates Cellulaires 1D et 2D. 21 janvier 2019. Université UPMC. <a href="http://chronos.isir.upmc.fr/~bredeche/Teaching/2i013/2018-2019/cours_2i013_2019_CA1DCA2D.pdf" target="_blank">Lien vers le PDF</a></li>
    </ol>
    </section>
</body>
</html>
